#
# This is file for drbl info zone generating
# $Id: do_info.pl,v 2.9 2003/10/27 14:48:13 agk Exp $
# 
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   Copyright 2002, Koulik Andrei <agk@agk.nnov.ru>
#

use strict;

# Code parameters

my $defalutConfig = '/usr/local/etc/drblnode.conf';

# global declarations
my %Config;
my ($Id,$Revision) = ('$Id: do_info.pl,v 2.9 2003/10/27 14:48:13 agk Exp $','$Revision: 2.9 $');
require '/usr/local/share/drbl/config.pl';
require '/usr/local/share/drbl/drbllib.pl';

cfgDoFile( (defined($ARGV[0])) ? $ARGV[0] : $defalutConfig, \%Config )||
  die "cannot parse the config file\n";

#Build Info zone
my($infoFile,$header);

if ( not defined($Config{'info'} )) {
  outErr("Informational section not found");
  die "Fatal error\n";
}
$infoFile = cfgGetValue(\%Config,'info.output');
$header = cfgGetAltValue('header',$Config{'info'},$Config{'defaults'});

if ( not open(OINFO,">$infoFile") ) {
  outErr("Can't create info file $infoFile: $!");
  die "Fatal error\n";
}
outHeader(\*OINFO,$header) if $header;
print OINFO "\@\tIN\tTXT\t\"DRBL-Type=INFO\"\n";
print OINFO "\tIN\tTXT\t\"DRBL-Version=$Revision\"\n";
print OINFO "\tIN\tTXT\t\"DRBL-Desc=".$Config{"info"}->{'description'} ."\"\n";
print OINFO "\tIN\tTXT\t\"DRBL-Policy=".$Config{"info"}->{'policyurl'} ."\"\n";
print OINFO ("; Vote zones\n");

while( my($zn,$hp) = each( %{$Config{'vote'}} ) ) {
  next if defined $hp->{'private'};
  my $val;
  print OINFO "$zn\tIN\tTXT\t\"DRBL-Type=VOTE\"\n";
  $val = cfgGetValue($hp,'description');
  print OINFO "\tIN\tTXT\t\"DRBL-Desc=$val\"\n" if $val;
  $val = cfgGetValue($hp,'target');
  print OINFO "\tIN\tTXT\t\"DRBL-Target=$val\"\n" if $val;
  $val = cfgGetValue($hp,'threshold');
  print OINFO "\tIN\tTXT\t\"DRBL-Threshold=$val\"\n" if $val;
}
print OINFO ("; Work zones\n");
while( my($zn,$hp) = each( %{$Config{'work'}} ) ) {
  next if defined $hp->{'private'};
  my $val;
  print OINFO "$zn\tIN\tTXT\t\"DRBL-Type=WORK\"\n";
  $val = cfgGetValue($hp,'description');
  print OINFO "\tIN\tTXT\t\"DRBL-Desc=$val\"\n" if $val;
  $val = cfgGetValue($hp,'target');
  print OINFO "\tIN\tTXT\t\"DRBL-Target=$val\"\n" if $val;
  $val = cfgGetValue($hp,'threshold');
  print OINFO "\tIN\tTXT\t\"DRBL-Threshold=$val\"\n" if $val;
  while( my($src,$shp) = each( %{$hp->{'src'}} ) ) {
    next if defined $shp->{'skip'};
    my($res,$target,$zone,$master,$weight);
    $res = parseTarget((defined $shp->{'origin'})?$shp->{'origin'}:$shp->{'target'},\$zone,\$master,\$weight);
    $weight = $shp->{'weight'} unless  $weight;

    if ($res == 5) {
      $target = "Local: $src/$weight";
    } else {
      $master = $shp->{'master'} unless $master;
      $target = "$zone\@$master/$weight";
    }
    print OINFO "\tIN\tTXT\t\"DRBL-Source=$target\"\n" if $val;
  }
}


close(OINFO);
